part of tecfy_core_client_package;

class DashboardChartComponenet extends StatefulWidget {
  final DashboardItemBase type;
  DashboardChartComponenet(this.type);
  @override
  _DashboardChartComponenetState createState() =>
      _DashboardChartComponenetState();
}

class _DashboardChartComponenetState extends State<DashboardChartComponenet> {
  onItemTab(type) async {
    if (type.onClick == null || type.onClick.isEmpty) return;
    if (type.onClick.startsWith('EntityList:')) {
      AppNavigator.navigateTo(context,
          () => EntityListPage(type.onClick.replaceAll('EntityList:', '')));
      return;
    }
    if (type.onClick.startsWith('Report:')) {
      var result = await ApiService.httpGetDynamic('Report/GetList');
      var reportName = type.onClick.replaceAll('Report:', '');
      AppNavigator.navigateTo(
          context,
          () => ReportDetailPage(
              result.data.firstWhere((s) => s['dbName'] == reportName), []));
      return;
    }
  }

  Future<dynamic> getData() async {
    var type = widget.type;
    if (type.value != null) return type.value;
    if (type.value == -1) return null;
    type.value = -1;
    var result =
        await ApiService.httpGetDynamic('Dashboard/GetData/${type.dbName}');
    if (!result.success) {
      result.data = jsonDecode(
          ConfigService.getValueString('DashboardType${type.dbName}'));
      result.success = result.data != null;
    }
    if (result.success) {
      ConfigService.setValueString(
          'DashboardType${type.dbName}', jsonEncode(result.data));
      //return result.data;
      type.value = result.data;
    }
    setState(() {});
    return type.value;
  }

  getWidth() {
    var fullwidth = LayoutService.getWidth(context);
    if (LayoutService.isMobile(context)) {
      return fullwidth - 20;
    }
    fullwidth -= (ThemeService.menuWidth + 40);
    if (fullwidth > ThemeService.containerWidth) {
      fullwidth = ThemeService.containerWidth - 40;
    }
    if (fullwidth < 600) {
      return fullwidth;
    }
    return fullwidth / 2;
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        //constraints: BoxConstraints(minWidth: 500,maxWidth: 500),
        width: getWidth(),
        padding: EdgeInsets.all(5),
        child: GestureDetector(
            onTap: () => onItemTab(widget.type),
            child: widget.type.dbName == 'SalesChart'
                ? LineChartSample1(widget.type)
                : BarChartSample2(widget.type)));
  }
}
