part of tecfy_core_client_package;

class ListFormProperty extends StatefulWidget {
  final String entityId;
  final String label;
  final bool isRequired;
  final bool readOnly;
  final List<dynamic> data;
  final void Function(List<dynamic>) onChanged;
  ListFormProperty(
      {this.entityId,
      this.label,
      this.isRequired,
      this.data,
      this.onChanged,
      this.readOnly = false});
  @override
  _ListFormPropertyState createState() => _ListFormPropertyState();
}

class _ListFormPropertyState extends AppState<ListFormProperty> {
  List<dynamic> items = [];
  Entity entity;

  @override
  void initState() {
    entity = EntityService.getEntity(widget.entityId);
    if (entity == null)
      print(
          'XXXXXXXXXXXX  Error Cannot find entity structure  ${widget.entityId}');
    items = widget.data ?? [];
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Column(
      children: items
          .map<Widget>((item) => InLineForm(widget.entityId,
              readOnly: widget.readOnly,
              entity: entity,
              data: item,
              onChanged: (v) => widget?.onChanged(items),
              onDismiss: (v) => setState(() => items.remove(v))))
          .toList()
            ..add(
              widget.readOnly
                  ? Container()
                  : SizedBox(
                      width: 250,
                      child: AppButtonIconText(
                        label: '${trans('Click to add new')} ${widget.label}',
                        icon: Icon(Icons.add, color: Colors.white),
                        onPressed: () async =>
                            setState(() => items.add(Map<String, dynamic>())),
                      ),
                    ),
            ),
    );
    // return ListView.builder(
    //   itemCount: items.length +1,
    //   itemBuilder: (c,i)=> i < items.length ? InLineForm(entity:entity,data:items[i],onChanged:(v)=> widget?.onChanged(items)) :

    //   FlatButton(child: Text('اضغط لاضافة سجل'),onPressed: ()=> setState(() =>items.add({}))),

    // );
  }
}
