part of tecfy_core_client_package;

class LocalRecordsPage extends StatefulWidget {
  @override
  _LocalRecordsPageState createState() => _LocalRecordsPageState();
}

class _LocalRecordsPageState extends AppState<LocalRecordsPage> {
  List<dynamic> _data;
  @override
  initState() {
    TecfySyncService.getLocalRecords().then((d) {
      _data = d;
      setState(() {});
    });
    super.initState();
  }

  onTab(item) async {
    if (item['type'] == 'Delete') {
      var result = await AppNavigator.confirmMessage(
          context, 'Are you sure you want to undo Delete?');
      if (result) {
        await TecfySyncService.undoDelete(item['id']);
        _data = await TecfySyncService.getLocalRecords();
        setState(() {});
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(
      context,
      AppLocale.translate(context, 'Local Database'),
      appBarActions: [
        TecfySyncService.isSyncing
            ? CircularProgressIndicator()
            : IconButton(
                tooltip: trans('Sync'),
                icon: Icon(Icons.sync_alt),
                onPressed: () async {
                  TecfySyncService.isSyncing = true;
                  setState(() {});
                  await TecfySyncService.syncNow();
                  _data = await TecfySyncService.getLocalRecords();
                  TecfySyncService.isSyncing = false;
                  setState(() {});
                })
      ],
      child: _data == null
          ? Center(child: CircularProgressIndicator())
          : SingleChildScrollView(
              child: DataTable(
                showCheckboxColumn: true,
                sortColumnIndex: 0,
                sortAscending: false,
                columns: [
                  DataColumn(label: Text(trans('Entity')), numeric: false),
                  DataColumn(label: Text(trans('Count')), numeric: true),
                ],
                rows: _data
                    .map<DataRow>((d) => DataRow(
                          cells: [
                            DataCell(Text(d['entityName'] ?? d['entity'] ?? ''),
                                onTap: () => onTab(d)),
                            DataCell(Text(d['count'].toString()),
                                onTap: () => onTab(d)),
                            // DataCell(Text(d['message'] ?? ''),
                            //     onTap: () => onTab(d)),
                          ],
                        ))
                    .toList(),
              ),
            ),
    );
  }
}
